#! /usr/bin/tawk -f
# Port of the Perl program 'client' to Unix T-AWK by Doug Dougherty, 8/20/99
# Note that this invokes "usocket.awk" automatically via the awklib feature
# Note also that all the stuff in the original Perl having to do with
# 'bind' is unnecessary.  That stuff required you to know your own IP
# address (which is obviously pretty silly...)
extern fork()
extern kill(int,int)
extern getppid()
function error(s) { print "Fatal error:",s > stderr ; abort() }
function octets(l) { local x=pack("@L",l),v;unpack("@B@B@B@B",x,v)
	return sprintf("%d.%d.%d.%d",v[1],v[2],v[3],v[4]) }
BEGIN {
target = ARGC > 1 ? ARGV[1] : "0"
port   = ARGC > 2 ? ARGV[2] : 13

if (port !~ /^[0-9]+$/) {	# This doesn't work - port is always 0
	if (typeof(val = getservbyname(port,"tcp")) == "uninitialized")
		error("getservbyname")
	for (i in val) print i,val[i]
	print "port =",port = val["s_port"]
	}
if (typeof(val = gethostbyname(target)) == "uninitialized")
	error("gethostbyname " target)
print "That is",octets(thataddr = val["h_addr"])

# global struct_sockaddr_in = "sin_family@s sin_port@S sin_addr@l @8x"
that = pack(struct_sockaddr_in,AF_INET,port,thataddr)

# Make the socket filehandle.  The TAWK socket lib makes this real easy.
if ((S = socket()))
	print "socket ok!"
else
	error("socket")

# Call up the server.

if (socket_connect(S,that))
	print "socket_connect ok!"
else
	error("socket_connect")

# If we are chatting with the finger daemon, we must send a blank line.
# If a third arg is set, we will actually finger that user...
if (port == 79) print ARGV[3] > S

# Avoid deadlock by forking.

if ((child = fork())) {	# Parent reads from user and writes the socket
    while (getline < "/dev/tty")
	print > S
    kill(child,9)	# Note: TAWK seems to block some signals, others
    exit		# generate ugly err msgs.  9 seems only clean way...
    }

while (getline < S)	# Child reads the socket and writes to the user
	print
kill(getppid(),15)
}
