# This program takes a hostname as argument.
# The argument can be a name ("anne") or internet address ("192.1.1.1")
# It queries the system for any aliases for that host, and prints them out.
function die(msg) {
	print "finger:",msg
	exit(2)
}

BEGIN {
	local sock
	local data
	local hostname = ARGV[1]
	local hostinfo, hostaddr
	if (ARGC == 1) { die("syntax: hostalias hostname") }
	# If user specifies an internet address (eg: 192.1.1.1), just use it
	if (hostname ~ /^[0-9.]+$/) {
		hostaddr = inet_addr(hostname)
		hostinfo = gethostbyaddr(hostaddr)
		if (length(hostinfo) == 0) {
			die("Host " hostname " did not respond.")
		}
	}
	else {
		hostinfo = gethostbyname(hostname)
		if (length(hostinfo) == 0) {
			die("Host " hostname " did not respond.")
		}
		# gethostbyname does not return aliases, so use gethostbyaddr.
		hostaddr = hostinfo["h_addr"]
		hostinfo = gethostbyaddr(hostaddr)
	}

	aliases = getaliases(hostinfo["h_aliases"])
	if (length(aliases)) {
		print "Aliases for",hostinfo["h_name"],"are:"
		for (i in aliases) print aliases[i]
	} else {
		print "No aliases returned for",hostinfo["h_name"]
	}
}
