# This code demonstrates how to use sockets.
# This program takes a hostname as argument.
# It contacts that host, and runs the finger command through the
# finger demon connected to Internet Port 79.
# Only works if the demon is running, of course.
function die(msg) {
	print "finger:",msg
	exit(2)
}

BEGIN {
	local sock
	local data
	local hostname = ARGV[1]
	local hostinfo, hostaddr
	if (ARGC == 1) { die("syntax: rfinger hostname") }
	# If user specifies an internet address (eg: 192.1.1.1), just use it
	if (hostname ~ /^[0-9.]+$/) { hostaddr = inet_addr(hostname) }
	else {
		hostinfo = gethostbyname(hostname)
		if (length(hostinfo) == 0) {
			die("Host " hostname " did not respond.")
		}
		hostaddr = hostinfo["h_addr"]
	}

	sock = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)
	if (sock == 0) {
		die("could not allocate socket")
	}
	# port 79 is reserved for use by finger daemons
	addr = pack(struct_sockaddr_in,AF_INET,79,hostaddr)
	# This works too: print "_connect =",_connect(fileno(sock),addr,16)
	if (! socket_connect(sock,addr)) {
		errno = socket_error()
		die("Could not connect to " hostname " at ip address " \
			inet_ntoa(hostaddr) " errno " errno)
	}

	print "Connected to",hostname,"at",inet_ntoa(hostaddr)
	# This tells the finger demon to return everything it knows
	if (OSMODE == 4) {
		# UNIX can just print/getline from sockets
		print "\n" > sock
		# Print out the returned information
		while (getline data < sock > 0) print data
	} else {
		socket_send(sock,"\n")
		while ((data = socket_recv(sock,1000))) printf("%s", data)
		print ""
	}
}
